#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

// Format getdatax.exe DataFilePath.csv SearchItemColumn1 [FoundReturnVariableName]
//		[FoundVariableValue] [NotFoundVariableValue] [ReturnVariableNameColumn2]
//		[ReturnVariableNameColumn3] [ReturnVariableNameColumn4] .......

// ** GetCommaDelString

void GetCommaDelString(const char* szInString, size_t& iidx, char* szOutString, size_t maxstr)
{
	size_t oidx = 0;
	maxstr--;
	while (true) {
		char c = szInString[iidx];
		if ((c == 0) || (c == ',') || (c == '\n') || (c == '\r')) {
			if (c == ',') iidx++;
			szOutString[oidx] = 0;
			return;
		}
		iidx++;
		if (oidx < maxstr) szOutString[oidx++] = c;
	}
}

// ** TrimString

void TrimString(char* szString)
{
	size_t ist = 0;
	while (szString[ist] == ' ' || szString[ist] == 34) ist++;
	if (ist) {
		int ost = 0;
		char c;
		do {
			c = szString[ist++];
			szString[ost++] = c;
		} while (c);
	}
	
	size_t ien = strlen(szString);
	while ((ien > 0) && (szString[ien - 1] == ' ' || szString[ien - 1] == 34)) ien--;
	szString[ien] = 0;
}

int main(int argc, char *argv[], char *[])
{
	setvbuf(stdout, NULL, _IONBF, 0);
	const char* szDataVariable = ((argc > 3) ? argv[3] : "data");
	const char* szFoundVariable = ((argc > 4) ? argv[4] : "found");
	const char* szNotFoundVariable = ((argc > 5) ? argv[5] : "not found");
	const char* szCopyright = "&copyright=NCH Swift Sound\n";

	char szStatusValue[256];
	strcpy(szStatusValue,szNotFoundVariable);

	if (argc > 2) {
		
		char szValue[256];
		strcpy(szValue, argv[2]);
		TrimString(szValue);
		
		FILE* fh;
		int cntr=0;
		time_t szSTime,szCTime;

		while(!(fh = fopen(argv[1], "r")) && cntr<5){
			time(&szSTime);
			time(&szCTime);
			while(difftime(szCTime, szSTime)<1)
				time(&szCTime);
			cntr++;
		}
		
		if (fh) {
			while (!feof(fh)) {
				size_t idx = 0;
				char szLine[512];
				if (fgets(szLine, 512, fh) == NULL) break;
				char szCurrentValue[256];
				GetCommaDelString(szLine, idx, szCurrentValue, sizeof szCurrentValue);
				TrimString(szCurrentValue);
				if (stricmp(szCurrentValue, szValue) == 0) {
					strcpy(szStatusValue,szFoundVariable);
					fclose(fh);
					printf("%s=%s", szDataVariable, szStatusValue);
					for( int i=6;i<argc;i++){
						char szData[256];
						GetCommaDelString(szLine, idx, szData, sizeof szData);
						TrimString(szData);
						printf("&%s=%s", argv[i], szData);
					}
					printf(szCopyright);	
					return 0;
				}
			}
			fclose(fh);
		}
		else
			printf("Error - File open failed\n");
	}
	printf(szCopyright);	
	printf("%s=%s", szDataVariable, szStatusValue);
	return 1;
}
